import 'package:vid/us/vid_us_image.dart';
import 'package:vid/us/vid_us_image_data.dart';
import 'package:vid/us/vid_us_probe.dart';

abstract class VidDataHostInterface {
  /// Vid文件链接
  String get url;

  /// 图像帧数
  int get frameCount;

  /// Vid Probe
  VidUsProbe get probe;

  /// 获取Vid信息
  Future<VidUsImageData?> getData();

  /// 加载文件信息
  Future<VidDataHostLoadInfo?> load();

  /// 获取帧
  ///
  /// [index] 帧索引
  ///
  /// [processors] 帧处理器集合
  Future<VidUsImage?> getFrame(int index);

  /// 释放Host
  Future<void> release();
}

class VidDataHostLoadInfo {
  VidDataHostLoadInfo(this.probe);
  final VidUsProbe probe;
}
