part of 'web.dart';

class _VidImageFetcherWebBrowser extends VidImageFetcherBase {
  VidFileDownloadCancelToken? _downloadCancelToken;

  _VidImageFetcherWebBrowser(String url) : super(url);

  @override
  Future<VidUsImage?> innerFetch() async {
    final bytes = await _loadVidFile();
    if (bytes != null && bytes.isNotEmpty) {
      final vidData = VidUsImageData(bytes);
      final frame = vidData.getImage(0);
      return frame;
    }
    return null;
  }

  @override
  void dispose() {
    _downloadCancelToken?.cancel();
  }

  Future<Uint8List?> _loadVidFile() async {
    _downloadCancelToken = VidFileDownloadCancelToken();
    final bytes = await VidFileDownloader.download(
      url,
      cancelToken: _downloadCancelToken,
    );
    return bytes;
  }
}
