import 'dart:convert';
import 'dart:typed_data';

import 'package:fis_jsonrpc/rpc.dart';
import 'package:fis_jsonrpc/services/platform.dart';
import 'package:fis_vid/common/env.dart';
import 'package:fis_vid/common/vid_download.dart';
import 'package:vid/us/vid_us_image.dart';
import 'package:vid/us/vid_us_image_data.dart';

import '../base.dart';

part 'browser.dart';
part 'shell.dart';

class VidImageFetcher extends VidImageFetcherBase {
  late final VidImageFetcherBase _inner;

  VidImageFetcher(String url) : super(url) {
    _inner = VidDataHostEnv.isShell
        ? _VidImageFetcherWebShell(url)
        : _VidImageFetcherWebBrowser(url);
  }

  @override
  Future<VidUsImage?> innerFetch() {
    return _inner.innerFetch();
  }

  @override
  void dispose() {
    _inner.dispose();
  }
}
